// FilterSelection.cpp : Implementierungsdatei
//

#include "stdafx.h"
#include "VPak.h"
#include "FilterSelection.h"


// CFilterSelection-Dialogfeld

IMPLEMENT_DYNAMIC(CFilterSelection, CDialog)
CFilterSelection::CFilterSelection(CVPakDlg* pParent /*=NULL*/)
	: CDialog(CFilterSelection::IDD, pParent)
{
}

CFilterSelection::~CFilterSelection()
{
}

void CFilterSelection::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_FILTER_LIST, m_FilterList);
}

BOOL CFilterSelection::OnInitDialog()
{
	CDialog::OnInitDialog();

	VFS_FilterNameList FilterNames;

    // Shouldn't ever happen...
	if( !VFS_GetFilterNames( FilterNames ) )
	{
		theApp.ReportError();
		return TRUE;
	}

    // Make a Filters List.
	m_FilterList.ResetContent();
	for( VFS_FilterNameList::const_iterator iter = FilterNames.begin(); iter != FilterNames.end(); iter++ )
	{
		m_FilterList.InsertString( 0, ( *iter ).c_str() );
	}

	return TRUE;
}


BEGIN_MESSAGE_MAP(CFilterSelection, CDialog)
	ON_BN_CLICKED(IDOK, OnOk)
END_MESSAGE_MAP()


// CFilterSelection-Meldungshandler

void CFilterSelection::OnOk()
{
	VFS_FilterNameList& FilterNames = ( ( CVPakDlg* )( GetParent() ) )->m_FilterNames;
	FilterNames.clear();
	for( INT nIndex = 0; nIndex < m_FilterList.GetCount(); nIndex++ )
	{
		if( m_FilterList.GetSel( nIndex ) )
		{
			CString strName;
			m_FilterList.GetText( nIndex, strName );
			FilterNames.push_back( VFS_String( strName ) );
		}
	}

	EndDialog( IDOK );
}
